diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ue-rrc.h ns-3.36/src/lte/model/lte-ue-rrc.h
--- ns-3.35/src/lte/model/lte-ue-rrc.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ue-rrc.h	2022-04-30 18:23:58.050734500 -0700
@@ -100,7 +100,7 @@
 
   /**
    * The states of the UE RRC entity
-   * 
+   *
    */
   enum State
   {
@@ -177,26 +177,26 @@
 
   /**
    * set the CMAC SAP this RRC should interact with
-   * \brief This function is overloaded to maintain backward compatibility 
+   * \brief This function is overloaded to maintain backward compatibility
    * \param s the CMAC SAP Provider to be used by this RRC
    */
   void SetLteUeCmacSapProvider (LteUeCmacSapProvider * s);
   /**
    * set the CMAC SAP this RRC should interact with
-   * \brief This function is overloaded to maintain backward compatibility 
+   * \brief This function is overloaded to maintain backward compatibility
    * \param s the CMAC SAP Provider to be used by this RRC
    * \param index the index
    */
   void SetLteUeCmacSapProvider (LteUeCmacSapProvider * s, uint8_t index);
 
   /**
-   * \brief This function is overloaded to maintain backward compatibility 
+   * \brief This function is overloaded to maintain backward compatibility
    * \return s the CMAC SAP User interface offered to the MAC by this RRC
    */
   LteUeCmacSapUser* GetLteUeCmacSapUser ();
   /**
    * \brief This function is overloaded to maintain backward compatibility
-   * \param index the index  
+   * \param index the index
    * \return s the CMAC SAP User interface offered to the MAC by this RRC
    */
   LteUeCmacSapUser* GetLteUeCmacSapUser (uint8_t index);
@@ -225,16 +225,16 @@
    */
   void SetLteMacSapProvider (LteMacSapProvider* s);
 
-  /** 
+  /**
    * Set the AS SAP user to interact with the NAS entity
-   * 
+   *
    * \param s the AS SAP user
    */
   void SetAsSapUser (LteAsSapUser* s);
 
-  /** 
-   * 
-   * 
+  /**
+   *
+   *
    * \return the AS SAP provider exported by this RRC
    */
   LteAsSapProvider* GetAsSapProvider ();
@@ -253,8 +253,8 @@
    */
   LteUeCcmRrcSapUser* GetLteCcmRrcSapUser ();
 
-  /** 
-   * 
+  /**
+   *
    * \param imsi the unique UE identifier
    */
   void SetImsi (uint64_t imsi);
@@ -284,12 +284,18 @@
    */
   uint16_t GetCellId () const;
 
-  /** 
+  /**
+   * \param cellId cell identifier
+   * \return true if cellId is the serving cell for this UE
+   */
+  bool IsServingCell (uint16_t cellId) const;
+
+  /**
    * \return the uplink bandwidth in RBs
    */
   uint8_t GetUlBandwidth () const;
 
-  /** 
+  /**
    * \return the downlink bandwidth in RBs
    */
   uint8_t GetDlBandwidth () const;
@@ -299,7 +305,7 @@
    */
   uint32_t GetDlEarfcn () const;
 
-  /** 
+  /**
    * \return the uplink carrier frequency (EARFCN)
    */
   uint32_t GetUlEarfcn () const;
@@ -317,14 +323,20 @@
    */
   uint16_t GetPreviousCellId () const;
 
-  /** 
-   * 
-   * 
+  /**
+   *
+   *
    * \param val true if RLC SM is to be used, false if RLC UM/AM are to be used
    */
   void SetUseRlcSm (bool val);
 
   /**
+   * \param s The UE RRC state.
+   * \return The string representation of the given state.
+   */
+  static const std::string ToString (LteUeRrc::State s);
+
+  /**
    * TracedCallback signature for imsi, cellId and rnti events.
    *
    * \param [in] imsi
@@ -425,7 +437,7 @@
   void DoNotifyRandomAccessSuccessful ();
   /// Notify random access failed function
   void DoNotifyRandomAccessFailed ();
- 
+
   // LTE AS SAP methods
   /**
    * Set CSG white list function
@@ -531,7 +543,7 @@
    */
   void DoSetNumberOfComponentCarriers (uint16_t noOfComponentCarriers);
 
- 
+
   // INTERNAL METHODS
 
   /**
@@ -624,6 +636,7 @@
    * \param rsrp measured RSRP value to be saved (in dBm)
    * \param rsrq measured RSRQ value to be saved (in dB)
    * \param useLayer3Filtering
+   * \param componentCarrierId
    * \todo Remove the useLayer3Filtering argument
    *
    * Implements Section 5.5.3.2 "Layer 3 filtering" of 3GPP TS 36.331. *Layer-3
@@ -640,27 +653,9 @@
    * \sa LteUeRrc::m_storedMeasValues
    */
   void SaveUeMeasurements (uint16_t cellId, double rsrp, double rsrq,
-                           bool useLayer3Filtering);
+                           bool useLayer3Filtering, uint8_t componentCarrierId);
 
   /**
-   * \brief keep the given measurement result as the latest measurement figures,
-   *        to be utilised by UE RRC functions.
-   * \param cellId the cell ID of the measured cell
-   * \param rsrp measured RSRP value to be saved (in dBm)
-   * \param rsrq measured RSRQ value to be saved (in dB)
-   * \param useLayer3Filtering
-   * \param componentCarrierId
-   * \todo Remove the useLayer3Filtering argument
-   *
-   * As for SaveUeMeasurements, this function aims to store the latest measurements
-   * related to the secondary component carriers.
-   * in the current implementation it saves only measurements related on the serving 
-   * secondary carriers while, measurements related to the Neighbor Cell are filtered
-   */
-
-  void SaveScellUeMeasurements (uint16_t cellId, double rsrp, double rsrq,
-                                bool useLayer3Filtering, uint16_t componentCarrierId);
-  /**
    * \brief Evaluate the reporting criteria of a measurement identity and
    *        invoke some reporting actions based on the result.
    * \param measId the measurement identity to be evaluated
@@ -1065,7 +1060,7 @@
   {
     double rsrp; ///< Measured RSRP in dBm.
     double rsrq; ///< Measured RSRQ in dB.
-    Time timestamp; ///< Not used. \todo Should be removed.
+    uint32_t carrierFreq; ///< Measurement object frequency
   };
 
   /**
@@ -1090,7 +1085,7 @@
 
   /**
    * \brief Internal storage of the latest measurement results from all detected
-   *        detected Secondary carrier component, indexed by the carrier component ID 
+   *        detected Secondary carrier component, indexed by the carrier component ID
    *        where the measurement was taken from.
    *
    * Each *measurement result* comprises of RSRP (in dBm) and RSRQ (in dB).
@@ -1337,7 +1332,7 @@
   void ResetRlfParams ();
 
 public:
-  /** 
+  /**
    * The number of component carriers.
    */
   uint16_t m_numberOfComponentCarriers;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/no-op-component-carrier-manager.cc ns-3.36/src/lte/model/no-op-component-carrier-manager.cc
--- ns-3.35/src/lte/model/no-op-component-carrier-manager.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/no-op-component-carrier-manager.cc	2022-04-30 18:23:58.050734500 -0700
@@ -102,25 +102,18 @@
 NoOpComponentCarrierManager::DoNotifyTxOpportunity (LteMacSapUser::TxOpportunityParameters txOpParams)
 {
   NS_LOG_FUNCTION (this);
-  std::map <uint16_t, std::map<uint8_t, LteMacSapUser*> >::iterator rntiIt = m_ueAttached.find (txOpParams.rnti);
-  NS_ASSERT_MSG (rntiIt != m_ueAttached.end (), "could not find RNTI" << txOpParams.rnti);
-  std::map<uint8_t, LteMacSapUser*>::iterator lcidIt = rntiIt->second.find (txOpParams.lcid);
-  NS_ASSERT_MSG (lcidIt != rntiIt->second.end (), "could not find LCID " << (uint16_t) txOpParams.lcid);
-  NS_LOG_DEBUG (this << " rnti= " << txOpParams.rnti << " lcid= " << (uint32_t) txOpParams.lcid << " layer= " << (uint32_t)txOpParams.layer<<" ccId="<< (uint32_t)txOpParams.componentCarrierId);
-  (*lcidIt).second->NotifyTxOpportunity (txOpParams);
-
+  NS_LOG_DEBUG (this << " rnti= " << txOpParams.rnti << " lcid= " << +txOpParams.lcid << " layer= " << +txOpParams.layer << " ccId=" << +txOpParams.componentCarrierId);
+  m_ueInfo.at (txOpParams.rnti).m_ueAttached.at (txOpParams.lcid)->NotifyTxOpportunity (txOpParams);
 }
 
 void
 NoOpComponentCarrierManager::DoReceivePdu (LteMacSapUser::ReceivePduParameters rxPduParams)
 {
   NS_LOG_FUNCTION (this);
-  std::map <uint16_t, std::map<uint8_t, LteMacSapUser*> >::iterator rntiIt = m_ueAttached.find (rxPduParams.rnti);
-  NS_ASSERT_MSG (rntiIt != m_ueAttached.end (), "could not find RNTI" << rxPduParams.rnti);
-  std::map<uint8_t, LteMacSapUser*>::iterator lcidIt = rntiIt->second.find (rxPduParams.lcid);
-  if (lcidIt != rntiIt->second.end ())
+  auto lcidIt = m_ueInfo.at (rxPduParams.rnti).m_ueAttached.find (rxPduParams.lcid);
+  if (lcidIt != m_ueInfo.at (rxPduParams.rnti).m_ueAttached.end ())
     {
-      (*lcidIt).second->ReceivePdu (rxPduParams);
+      lcidIt->second->ReceivePdu (rxPduParams);
     }
 }
 
@@ -141,61 +134,34 @@
 NoOpComponentCarrierManager::DoAddUe (uint16_t rnti, uint8_t state)
 {
   NS_LOG_FUNCTION (this << rnti << (uint16_t) state);
-  std::map<uint16_t, uint8_t>::iterator stateIt;
   std::map<uint16_t, uint8_t>::iterator eccIt; // m_enabledComponentCarrier iterator
-  stateIt = m_ueState.find (rnti);
-  if (stateIt == m_ueState.end ())
+  auto ueInfoIt = m_ueInfo.find (rnti);
+  if (ueInfoIt == m_ueInfo.end ())
     {
-      //      NS_ASSERT_MSG ((stateIt == m_ueState.end () && state == 3), " ERROR: Ue was not indexed and current state is CONNECTED_NORMALLY" << (uint16_t) state);
       NS_LOG_DEBUG (this << " UE " << rnti << " was not found, now it is added in the map");
-      m_ueState.insert (std::pair<uint16_t, uint8_t> (rnti, state));
-      eccIt = m_enabledComponentCarrier.find (rnti);
-      //if ((state == 7 || state == 0) && eccIt == m_enabledComponentCarrier.end ())
-      if (eccIt == m_enabledComponentCarrier.end ())
-        {
-          // the Primary carrier (PC) is enabled by default
-          // on the PC the SRB0 and SRB1 are enabled when the Ue is connected
-          // these are hard-coded and the configuration not pass through the
-          // Component Carrier Manager which is responsible of configure
-          // only DataRadioBearer on the different Component Carrier
-          m_enabledComponentCarrier.insert (std::pair<uint16_t, uint8_t> (rnti, 1));
-        }
-      else
-        {
-          NS_FATAL_ERROR (this << " Ue " << rnti << " had Component Carrier enabled before join the network" << (uint16_t) state);
-        }
-      // preparing the rnti,lcid,LteMacSapUser map
-      std::map<uint8_t, LteMacSapUser*> empty;
-      std::pair <std::map <uint16_t, std::map<uint8_t, LteMacSapUser*> >::iterator, bool>
-      ret = m_ueAttached.insert (std::pair <uint16_t,  std::map<uint8_t, LteMacSapUser*> >
-      (rnti, empty));
-      NS_LOG_DEBUG (this << "AddUe: UE Pointer LteMacSapUser Map " << rnti << " added " << (uint16_t) ret.second);
-      NS_ASSERT_MSG (ret.second, "element already present, RNTI already existed");
-
-      //add new rnti in the map
-      std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> emptyA;
-      std::pair <std::map <uint16_t, std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> >::iterator, bool>
-      retA = m_rlcLcInstantiated.insert (std::pair <uint16_t,  std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> >
-      (rnti, emptyA));
-      NS_ASSERT_MSG (retA.second, "element already present, RNTI already existed");
-      NS_LOG_DEBUG (this << "AddUe: UE " << rnti << " added " << (uint16_t) retA.second);
+      UeInfo info;
+      info.m_ueState = state;
 
+      // the Primary carrier (PC) is enabled by default
+      // on the PC the SRB0 and SRB1 are enabled when the Ue is connected
+      // these are hard-coded and the configuration not pass through the
+      // Component Carrier Manager which is responsible of configure
+      // only DataRadioBearer on the different Component Carrier
+      info.m_enabledComponentCarrier = 1;
+      m_ueInfo.emplace (rnti, info);
     }
   else
     {
-      NS_LOG_DEBUG (this << " UE " << rnti << "found, updating the state from " << (uint16_t) stateIt->second << " to " << (uint16_t) state);
-      stateIt->second = state;
+      NS_LOG_DEBUG (this << " UE " << rnti << "found, updating the state from " << +ueInfoIt->second.m_ueState << " to " << +state);
+      ueInfoIt->second.m_ueState = state;
     }
-
-
 }
 
 void
 NoOpComponentCarrierManager::DoAddLc (LteEnbCmacSapProvider::LcInfo lcInfo, LteMacSapUser* msu)
 {
   NS_LOG_FUNCTION (this);
-  NS_ASSERT_MSG( m_rlcLcInstantiated.find(lcInfo.rnti) != m_rlcLcInstantiated.end(), "Adding lc for a user that was not yet added to component carrier manager list.");
-  m_rlcLcInstantiated.find(lcInfo.rnti)->second.insert(std::pair <uint8_t, LteEnbCmacSapProvider::LcInfo> (lcInfo.lcId, lcInfo));
+  m_ueInfo.at (lcInfo.rnti).m_rlcLcInstantiated.emplace (lcInfo.lcId, lcInfo);
 }
 
 
@@ -203,37 +169,20 @@
 NoOpComponentCarrierManager::DoRemoveUe (uint16_t rnti)
 {
   NS_LOG_FUNCTION (this);
-  std::map<uint16_t, uint8_t>::iterator stateIt;
-  std::map<uint16_t, uint8_t>::iterator eccIt; // m_enabledComponentCarrier iterator
-  stateIt = m_ueState.find (rnti);
-  eccIt = m_enabledComponentCarrier.find (rnti);
-  NS_ASSERT_MSG (stateIt != m_ueState.end (), "request to remove UE info with unknown rnti ");
-  NS_ASSERT_MSG (eccIt != m_enabledComponentCarrier.end (), "request to remove UE info with unknown rnti ");
-
-  //std::map <uint16_t, std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> >::iterator lcsIt;
-  auto rlcLcIt = m_rlcLcInstantiated.find (rnti);
-  NS_ASSERT_MSG (rlcLcIt != m_rlcLcInstantiated.end (), "request to Release Data Radio Bearer on UE without Logical Channels enabled");
-
-  auto rntiIt = m_ueAttached.find (rnti);
-
-  NS_ASSERT_MSG (rntiIt != m_ueAttached.end (), "request to Release Data Radio Bearer on unattached UE");
-
-  m_ueState.erase (rnti);
-  m_enabledComponentCarrier.erase (rnti);
-  m_rlcLcInstantiated.erase (rnti);
-  m_ueAttached.erase (rnti);
+  auto rntiIt = m_ueInfo.find (rnti);
+  NS_ASSERT_MSG (rntiIt != m_ueInfo.end (), "request to remove UE info with unknown RNTI " << rnti);
+  m_ueInfo.erase (rntiIt);
 }
 
 std::vector<LteCcmRrcSapProvider::LcsConfig>
 NoOpComponentCarrierManager::DoSetupDataRadioBearer (EpsBearer bearer, uint8_t bearerId, uint16_t rnti, uint8_t lcid, uint8_t lcGroup, LteMacSapUser *msu)
 {
   NS_LOG_FUNCTION (this << rnti);
-  std::map<uint16_t, uint8_t>::iterator eccIt; // m_enabledComponentCarrier iterator
-  eccIt = m_enabledComponentCarrier.find (rnti);
-  NS_ASSERT_MSG (eccIt != m_enabledComponentCarrier.end (), "SetupDataRadioBearer on unknown rnti ");
+  auto rntiIt = m_ueInfo.find (rnti);
+  NS_ASSERT_MSG (rntiIt != m_ueInfo.end (), "SetupDataRadioBearer on unknown RNTI " << rnti);
 
   // enable by default all carriers
-  eccIt->second = m_noOfComponentCarriers;
+  rntiIt->second.m_enabledComponentCarrier = m_noOfComponentCarriers;
 
   std::vector<LteCcmRrcSapProvider::LcsConfig> res;
   LteCcmRrcSapProvider::LcsConfig entry;
@@ -270,31 +219,8 @@
       res.push_back (entry);
     } // end for
 
-
-  // preparing the rnti,lcid,LcInfo map
-  std::map <uint16_t, std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> >::iterator rntiIter = m_rlcLcInstantiated.find (rnti);
-  rntiIter = m_rlcLcInstantiated.begin ();
-  // while (rntiIter != m_rlcLcInstantiated.end ())
-  //   {
-  //     ++rntiIter;
-  //   }
-  // if (rntiIt == m_rlcLcInstantiated.end ())
-  //   {
-  //     //add new rnti in the map
-  //     std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> empty;
-  //     std::pair <std::map <uint16_t, std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> >::iterator, bool>
-  //       ret = m_rlcLcInstantiated.insert (std::pair <uint16_t,  std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> >
-  //                                         (rnti, empty));
-  //     NS_LOG_DEBUG (this << " UE " << rnti << " added " << (uint16_t) ret.second);
-  //   }
-
-  std::map <uint16_t, std::map<uint8_t, LteMacSapUser*> >::iterator sapIt =  m_ueAttached.find (rnti);
-  NS_ASSERT_MSG (sapIt != m_ueAttached.end (), "RNTI not found");
-  rntiIter = m_rlcLcInstantiated.find (rnti);
-  std::map<uint8_t, LteEnbCmacSapProvider::LcInfo>::iterator lcidIt = rntiIter->second.find (lcid);
-  //std::map<uint8_t, LteMacSapUser*>::iterator lcidIt = sapIt->second.find (lcinfo.lcId);
-  NS_ASSERT_MSG (rntiIter != m_rlcLcInstantiated.end (), "RNTI not found");
-  if (lcidIt == rntiIter->second.end ())
+  auto lcidIt = rntiIt->second.m_rlcLcInstantiated.find (lcid);
+  if (lcidIt == rntiIt->second.m_rlcLcInstantiated.end ())
     {
       lcinfo.rnti = rnti;
       lcinfo.lcId = lcid;
@@ -305,8 +231,8 @@
       lcinfo.mbrDl = bearer.gbrQosInfo.mbrDl;
       lcinfo.gbrUl = bearer.gbrQosInfo.gbrUl;
       lcinfo.gbrDl = bearer.gbrQosInfo.gbrDl;
-      rntiIter->second.insert (std::pair<uint8_t, LteEnbCmacSapProvider::LcInfo> (lcinfo.lcId, lcinfo));
-      sapIt->second.insert (std::pair<uint8_t, LteMacSapUser*> (lcinfo.lcId, msu));
+      rntiIt->second.m_rlcLcInstantiated.emplace (lcinfo.lcId, lcinfo);
+      rntiIt->second.m_ueAttached.emplace (lcinfo.lcId, msu);
     }
   else
     {
@@ -319,48 +245,43 @@
 std::vector<uint8_t>
 NoOpComponentCarrierManager::DoReleaseDataRadioBearer (uint16_t rnti, uint8_t lcid)
 {
-  NS_LOG_FUNCTION (this);
-  // here we receive directly the rnti and the lcid, instead of only drbid
-  // drbid are mapped as drbid = lcid + 2
-  std::map<uint16_t, uint8_t>::iterator eccIt; // m_enabledComponentCarrier iterator
-  eccIt= m_enabledComponentCarrier.find (rnti);
-  NS_ASSERT_MSG (eccIt != m_enabledComponentCarrier.end (), "request to Release Data Radio Bearer on Ue without Component Carrier Enabled");
-  std::map <uint16_t, std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> >::iterator lcsIt;
-  lcsIt = m_rlcLcInstantiated.find (rnti);
-  NS_ASSERT_MSG (lcsIt != m_rlcLcInstantiated.end (), "request to Release Data Radio Bearer on Ue without Logical Channels enabled");
-  std::map<uint8_t, LteEnbCmacSapProvider::LcInfo>::iterator lcIt;
-  NS_LOG_DEBUG (this << " remove lcid " << (uint16_t) lcid << " for rnti " << rnti);
-  lcIt = lcsIt->second.find (lcid);
-  NS_ASSERT_MSG (lcIt != lcsIt->second.end (), " Logical Channel not found");
+  NS_LOG_FUNCTION (this << rnti << +lcid);
+  
+  // Here we receive directly the RNTI and the LCID, instead of only DRB ID
+  // DRB ID are mapped as DRBID = LCID + 2
+  auto rntiIt = m_ueInfo.find (rnti);
+  NS_ASSERT_MSG (rntiIt != m_ueInfo.end (), "request to Release Data Radio Bearer on UE with unknown RNTI " << rnti);
+
+  NS_LOG_DEBUG (this << " remove LCID " << +lcid << " for RNTI " << rnti);
   std::vector<uint8_t> res;
-  for (uint16_t i = 0; i < eccIt->second; i++)
+  for (uint16_t i = 0; i < rntiIt->second.m_enabledComponentCarrier; i++)
     {
       res.insert (res.end (), i);
     }
-  //Find user based on rnti and then erase lcid stored against the same
-  std::map <uint16_t, std::map<uint8_t, LteMacSapUser*> >::iterator rntiIt = m_ueAttached.find (rnti);
-  rntiIt->second.erase (lcid);
-  std::map <uint16_t, std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> >::iterator rlcInstancesIt = m_rlcLcInstantiated.find (rnti);
-  std::map<uint8_t, LteEnbCmacSapProvider::LcInfo>::iterator rclLcIt;
-  lcIt = rlcInstancesIt->second.find (lcid);
-  NS_ASSERT_MSG (lcIt != lcsIt->second.end (), " Erasing: Logical Channel not found");
-  lcsIt->second.erase (lcid);
+
+  auto lcIt = rntiIt->second.m_ueAttached.find (lcid);
+  NS_ASSERT_MSG (lcIt != rntiIt->second.m_ueAttached.end (), "Logical Channel not found");
+  rntiIt->second.m_ueAttached.erase (lcIt);
+
+  auto rlcInstancesIt = rntiIt->second.m_rlcLcInstantiated.find (rnti);
+  NS_ASSERT_MSG (rlcInstancesIt != rntiIt->second.m_rlcLcInstantiated.end (), "Logical Channel not found");
+  rntiIt->second.m_rlcLcInstantiated.erase (rlcInstancesIt);
+
   return res;
 }
 
 LteMacSapUser*
-NoOpComponentCarrierManager::DoConfigureSignalBearer(LteEnbCmacSapProvider::LcInfo lcinfo,  LteMacSapUser* msu)
+NoOpComponentCarrierManager::DoConfigureSignalBearer(LteEnbCmacSapProvider::LcInfo lcinfo, LteMacSapUser* msu)
 {
   NS_LOG_FUNCTION (this);
-  std::map <uint16_t, std::map<uint8_t, LteMacSapUser*> >::iterator itSapUserAtCcm;
-  itSapUserAtCcm = m_ueAttached.find (lcinfo.rnti);
-  NS_ASSERT_MSG (itSapUserAtCcm != m_ueAttached.end (), "request to Add a SignalBearer to unknown rnti");
-  std::map <uint16_t, std::map<uint8_t, LteMacSapUser*> >::iterator rntiIt = m_ueAttached.find (lcinfo.rnti);
-  NS_ASSERT_MSG (rntiIt != m_ueAttached.end (), "RNTI not found");
-  std::map<uint8_t, LteMacSapUser*>::iterator lcidIt = rntiIt->second.find (lcinfo.lcId);
-  if (lcidIt == rntiIt->second.end ())
+
+  auto rntiIt = m_ueInfo.find (lcinfo.rnti);
+  NS_ASSERT_MSG (rntiIt != m_ueInfo.end (), "request to add a signal bearer to unknown RNTI " << lcinfo.rnti);
+
+  auto lcidIt = rntiIt->second.m_ueAttached.find (lcinfo.lcId);
+  if (lcidIt == rntiIt->second.m_ueAttached.end ())
     {
-      rntiIt->second.insert (std::pair<uint8_t, LteMacSapUser*> (lcinfo.lcId, msu));
+      rntiIt->second.m_ueAttached.emplace (lcinfo.lcId, msu);
     }
   else
     {
@@ -468,9 +389,7 @@
 {
   NS_LOG_FUNCTION (this);
 
-  NS_ASSERT_MSG( m_enabledComponentCarrier.find(params.rnti)!=m_enabledComponentCarrier.end(), " UE with provided RNTI not found. RNTI:"<<params.rnti);
-
-  uint32_t numberOfCarriersForUe = m_enabledComponentCarrier.find (params.rnti)->second;
+  uint32_t numberOfCarriersForUe = m_ueInfo.at (params.rnti).m_enabledComponentCarrier;
   if (params.lcid == 0 || params.lcid == 1 || numberOfCarriersForUe == 1)
     {
       NS_LOG_INFO("Buffer status forwarded to the primary carrier.");
@@ -484,7 +403,7 @@
       for ( uint16_t i = 0;  i < numberOfCarriersForUe ; i++)
         {
           NS_ASSERT_MSG (m_macSapProvidersMap.find(i)!=m_macSapProvidersMap.end(), "Mac sap provider does not exist.");
-          m_macSapProvidersMap.find(i)->second->ReportBufferStatus(params);
+          m_macSapProvidersMap.at (i)->ReportBufferStatus(params);
         }
     }
 }
@@ -498,7 +417,7 @@
   NS_ASSERT_MSG (bsr.m_macCeType == MacCeListElement_s::BSR, "Received a Control Message not allowed " << bsr.m_macCeType);
 
   // split traffic in uplink equally among carriers
-  uint32_t numberOfCarriersForUe = m_enabledComponentCarrier.find(bsr.m_rnti)->second;
+  uint32_t numberOfCarriersForUe = m_ueInfo.at (bsr.m_rnti).m_enabledComponentCarrier;
 
   if ( bsr.m_macCeType == MacCeListElement_s::BSR)
     {
@@ -540,12 +459,11 @@
 }
 
 void
-RrComponentCarrierManager::DoUlReceiveSr(uint16_t rnti, uint8_t componentCarrierId)
+RrComponentCarrierManager::DoUlReceiveSr(uint16_t rnti, [[maybe_unused]] uint8_t componentCarrierId)
 {
   NS_LOG_FUNCTION (this);
-  NS_UNUSED (componentCarrierId);
   // split traffic in uplink equally among carriers
-  uint32_t numberOfCarriersForUe = m_enabledComponentCarrier.find (rnti)->second;
+  uint32_t numberOfCarriersForUe = m_ueInfo.at (rnti).m_enabledComponentCarrier;
 
   m_ccmMacSapProviderMap.find (m_lastCcIdForSr)->second->ReportSrToScheduler (rnti);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/rem-spectrum-phy.cc ns-3.36/src/lte/model/rem-spectrum-phy.cc
--- ns-3.35/src/lte/model/rem-spectrum-phy.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/rem-spectrum-phy.cc	2022-04-30 18:23:58.050734500 -0700
@@ -114,8 +114,8 @@
   return m_rxSpectrumModel;
 }
 
-Ptr<AntennaModel>
-RemSpectrumPhy::GetRxAntenna () const
+Ptr<Object>
+RemSpectrumPhy::GetAntenna () const
 {
   return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/rem-spectrum-phy.h ns-3.36/src/lte/model/rem-spectrum-phy.h
--- ns-3.35/src/lte/model/rem-spectrum-phy.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/rem-spectrum-phy.h	2022-04-30 18:23:58.050734500 -0700
@@ -70,7 +70,7 @@
   Ptr<MobilityModel> GetMobility () const;
   Ptr<NetDevice> GetDevice () const;
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna () const;
+  Ptr<Object> GetAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
 
   /** 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/tta-ff-mac-scheduler.cc ns-3.36/src/lte/model/tta-ff-mac-scheduler.cc
--- ns-3.35/src/lte/model/tta-ff-mac-scheduler.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/tta-ff-mac-scheduler.cc	2022-04-30 18:23:58.050734500 -0700
@@ -1059,15 +1059,12 @@
         {
           NS_LOG_INFO (this << " Layer " << (uint16_t)j << " CQI selected " << (uint16_t)worstCqi.at (j));
         }
-      uint32_t bytesTxed = 0;
       for (uint8_t j = 0; j < nLayer; j++)
         {
           newDci.m_mcs.push_back (m_amc->GetMcsFromCqi (worstCqi.at (j)));
           int tbSize = (m_amc->GetDlTbSizeFromMcs (newDci.m_mcs.at (j), RgbPerRnti * rbgSize) / 8); // (size of TB in bytes according to table 7.1.7.2.1-1 of 36.213)
           newDci.m_tbsSize.push_back (tbSize);
           NS_LOG_INFO (this << " Layer " << (uint16_t)j << " MCS selected" << m_amc->GetMcsFromCqi (worstCqi.at (j)));
-
-          bytesTxed += tbSize;
         }
 
       newDci.m_resAlloc = 0;  // only allocation type 0 at this stage
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/epc-test-run-time.pl ns-3.36/src/lte/test/epc-test-run-time.pl
--- ns-3.35/src/lte/test/epc-test-run-time.pl	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/epc-test-run-time.pl	2022-04-30 18:23:58.050734500 -0700
@@ -14,10 +14,10 @@
 
 
 # Configure and complite first the program to avoid counting compilation time as running time
-my $launch = "CXXFLAGS=\"-O3 -w\" ./waf -d optimized configure --enable-static --enable-examples --enable-modules=lte";
+my $launch = "CXXFLAGS=\"-O3 -w\" ./ns3 configure -d optimized --enable-static --enable-examples --enable-modules=lte";
 my $out, my $err;
 capture { system($launch ) } \$out, \$err;
-$launch = "./waf --run \'lena-profiling --simTime=0.1 --nUe=1 --nEnb=1 --nFloors=0\'";
+$launch = "./ns3 run \'lena-profiling --simTime=0.1 --nUe=1 --nEnb=1 --nFloors=0\'";
 
 foreach my $time (@simTime)
 {
@@ -26,7 +26,7 @@
             my $timeStats = Statistics::Descriptive::Full->new();
             for ( my $iteration = 0 ; $iteration < $nIterations ; $iteration++ )
             {
-               $launch = "time -f \"real%E\" ./waf --run 'lena-simple-epc --simTime=$time --numberOfNodes=$node'";
+               $launch = "time -f \"real%E\" ./ns3 run 'lena-simple-epc --simTime=$time --numberOfNodes=$node'";
                print "$launch\n";
                capture { system($launch ) } \$out, \$err;
                $err =~ /real(.+):(.+)/;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/epc-test-s1u-downlink.cc ns-3.36/src/lte/test/epc-test-s1u-downlink.cc
--- ns-3.35/src/lte/test/epc-test-s1u-downlink.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/epc-test-s1u-downlink.cc	2022-04-30 18:23:58.054734500 -0700
@@ -189,7 +189,9 @@
       Ptr<NetDevice> enbDevice = cellDevices.Get (cellDevices.GetN () - 1);
 
       // Note that the EpcEnbApplication won't care of the actual NetDevice type
-      epcHelper->AddEnb (enb, enbDevice, cellId);      
+      std::vector<uint16_t> cellIds;
+      cellIds.push_back (cellId);
+      epcHelper->AddEnb (enb, enbDevice, cellIds);
 
       // Plug test RRC entity
       Ptr<EpcEnbApplication> enbApp = enb->GetApplication (0)->GetObject<EpcEnbApplication> ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/epc-test-s1u-uplink.cc ns-3.36/src/lte/test/epc-test-s1u-uplink.cc
--- ns-3.35/src/lte/test/epc-test-s1u-uplink.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/epc-test-s1u-uplink.cc	2022-04-30 18:23:58.054734500 -0700
@@ -402,7 +402,9 @@
       Ptr<NetDevice> enbDevice = cellDevices.Get (cellDevices.GetN () - 1);
 
       // Note that the EpcEnbApplication won't care of the actual NetDevice type
-      epcHelper->AddEnb (enb, enbDevice, cellId);
+      std::vector<uint16_t> cellIds;
+      cellIds.push_back (cellId);
+      epcHelper->AddEnb (enb, enbDevice, cellIds);
 
       // Plug test RRC entity
       Ptr<EpcEnbApplication> enbApp = enb->GetApplication (0)->GetObject<EpcEnbApplication> ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/lte-simple-spectrum-phy.cc ns-3.36/src/lte/test/lte-simple-spectrum-phy.cc
--- ns-3.35/src/lte/test/lte-simple-spectrum-phy.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/lte-simple-spectrum-phy.cc	2022-04-30 18:23:58.054734500 -0700
@@ -118,8 +118,8 @@
 }
 
 
-Ptr<AntennaModel>
-LteSimpleSpectrumPhy::GetRxAntenna () const
+Ptr<Object>
+LteSimpleSpectrumPhy::GetAntenna () const
 {
   return m_antenna;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/lte-simple-spectrum-phy.h ns-3.36/src/lte/test/lte-simple-spectrum-phy.h
--- ns-3.35/src/lte/test/lte-simple-spectrum-phy.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/lte-simple-spectrum-phy.h	2022-04-30 18:23:58.054734500 -0700
@@ -66,7 +66,7 @@
   Ptr<MobilityModel> GetMobility () const;
   Ptr<NetDevice> GetDevice () const;
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna () const;
+  Ptr<Object> GetAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/lte-test-harq.cc ns-3.36/src/lte/test/lte-test-harq.cc
--- ns-3.35/src/lte/test/lte-test-harq.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/lte-test-harq.cc	2022-04-30 18:23:58.058734400 -0700
@@ -46,7 +46,6 @@
 #include <ns3/config.h>
 #include <ns3/boolean.h>
 #include <ns3/enum.h>
-#include <ns3/unused.h>
 #include <ns3/ff-mac-scheduler.h>
 #include <ns3/buildings-helper.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/lte-test-phy-error-model.cc ns-3.36/src/lte/test/lte-test-phy-error-model.cc
--- ns-3.35/src/lte/test/lte-test-phy-error-model.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/lte-test-phy-error-model.cc	2022-04-30 18:23:58.062734600 -0700
@@ -47,7 +47,6 @@
 #include <ns3/boolean.h>
 #include <ns3/enum.h>
 #include <ns3/integer.h>
-#include <ns3/unused.h>
 #include <ns3/ff-mac-scheduler.h>
 #include <ns3/buildings-helper.h>
 
@@ -258,7 +257,7 @@
 
       double dlRxPackets = rlcStats->GetDlRxPackets (imsi, lcId);
       double dlTxPackets = rlcStats->GetDlTxPackets (imsi, lcId);
-      double dlBler =  1.0 - (dlRxPackets/dlTxPackets);
+      [[maybe_unused]] double dlBler =  1.0 - (dlRxPackets/dlTxPackets);
       double expectedDlRxPackets = dlTxPackets -dlTxPackets*m_blerRef;
       NS_LOG_INFO ("\tUser " << i << " imsi " << imsi << " DOWNLINK"
                    << " pkts rx " << dlRxPackets << " tx " << dlTxPackets
@@ -266,7 +265,6 @@
                    << " expected rx " << expectedDlRxPackets
                    << " difference " << std::abs (expectedDlRxPackets - dlRxPackets)
                    << " tolerance " << m_toleranceRxPackets);
-      NS_UNUSED (dlBler);
 
       // sanity check for whether the tx packets reported by the stats are correct
       // we expect one packet per TTI
@@ -417,7 +415,7 @@
       uint8_t lcId = 3;
       double dlRxPackets = rlcStats->GetDlRxPackets (imsi, lcId);
       double dlTxPackets = rlcStats->GetDlTxPackets (imsi, lcId);
-      double dlBler = 1.0 - (dlRxPackets/dlTxPackets);
+      [[maybe_unused]] double dlBler = 1.0 - (dlRxPackets/dlTxPackets);
       double expectedDlRxPackets = dlTxPackets -dlTxPackets*m_blerRef;
       NS_LOG_INFO ("\tUser " << i << " imsi " << imsi << " DOWNLINK"
                    << " pkts rx " << dlRxPackets << " tx " << dlTxPackets
@@ -425,7 +423,6 @@
                    << " expected rx " << expectedDlRxPackets
                    << " difference " << std::abs (expectedDlRxPackets - dlRxPackets)
                    << " tolerance " << m_toleranceRxPackets);
-      NS_UNUSED (dlBler);
 
       // sanity check for whether the tx packets reported by the stats are correct
       // we expect one packet per TTI
